############################################################
#
# <p>BingImageSearch</p>
# <pre>
# {{bingimage ŵ롼}}
# </pre>
#
############################################################
package plugin::bing::BingImage;
use strict;
use LWP::UserAgent;
use JSON::XS qw/decode_json/;
use Encode qw /decode encode from_to/;
use Encode::JavaScript::UCS;
use HTTP::Request;
use Unicode::Japanese;
use plugin::bing::BingAppID;
#use Data::Dumper;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}

#===========================================================
# ѥ饰ե᥽å
#===========================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $word = shift;
  my $tb = shift;
  my $results = shift;

  if($results eq ""){
    $results = 1;
  }
  if($results > 50){
    $results = 50;
  }

  my $id = &plugin::bing::BingAppID::get_app_id();

  from_to($word,"euc-jp","utf8");

  my $url = URI->new('https://api.datamarket.azure.com/Bing/Search/Image');
  $url->query_form(
    'Query'   => qq{'$word'},
    '$top'    => $results,
    '$format' => 'json',
  );

  my $req = HTTP::Request->new(GET => $url);
  $req->authorization_basic('', $id);

  my $ua = LWP::UserAgent->new;
  my $response = $ua->request($req);
  if ($response->is_error) {
      return $response->content;
  }

  my $data = decode_json $response->content;

  my $out = "<div class=\"bing\">";
  my $count = 0;

  foreach my $result (@{$data->{d}{results}}){
    $count++;
    last if($count > $results);

    my $MediaUrl = decode('JavaScript-UCS',$result->{MediaUrl});
    my $tbUrl = decode('JavaScript-UCS',$result->{Thumbnail}{MediaUrl});
    my $tbHeight = decode('JavaScript-UCS',$result->{Thumbnail}{Height});
    my $tbWidth = decode('JavaScript-UCS',$result->{Thumbnail}{Width});
    my $SourceUrl = decode('JavaScript-UCS',$result->{SourceUrl});
    my $Title = decode('JavaScript-UCS',$result->{Title});

    $out .= "$count.<a href=\"$MediaUrl\">$Title</a><br>";
    if($tb eq "tb"){
      $out .= "<a href=\"$MediaUrl\"><img src=\"$tbUrl\" width=\"$tbWidth\" height=\"$tbHeight\" alt=\"$Title\"></a><br>";
    }else{
      $out .= "<img src=\"$MediaUrl\" alt=\"$Title\"><br>";
    }
    $out .= "<b>RefererUrl:</b> <a href=\"$SourceUrl\">$SourceUrl</a><br><br>";
  }

  $out .= "</div>";

  $out = Unicode::Japanese->new($out,"utf8")->euc;

#$out = Dumper $data;

  return $out;
}

1;

