############################################################
#
# <p>BingWebSearch</p>
# <pre>
# {{bingweb ŵ롼}}
# </pre>
#
############################################################
package plugin::bing::BingWeb;
use strict;
use LWP::UserAgent;
use JSON::XS qw/decode_json/;
use Encode qw /decode encode from_to/;
use Encode::JavaScript::UCS;
use HTTP::Request;
use Unicode::Japanese;
use plugin::bing::BingAppID;
#use Data::Dumper;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}

#===========================================================
# ѥ饰ե᥽å
#===========================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $word = shift;
  my $results = shift;

  if($results eq ""){
    $results = 1;
  }
  if($results > 50){
    $results = 50;
  }

  my $id = &plugin::bing::BingAppID::get_app_id();

  from_to($word,"euc-jp","utf8");

  my $url = URI->new('https://api.datamarket.azure.com/Bing/Search/Web');
  $url->query_form(
    'Query'   => qq{'$word'},
    '$top'    => $results,
    '$format' => 'json',
  );

  my $req = HTTP::Request->new(GET => $url);
  $req->authorization_basic('', $id);

  my $ua = LWP::UserAgent->new;
  my $response = $ua->request($req);
  if ($response->is_error) {
      return $response->content;
  }

  my $data = decode_json $response->content;

  my $out = "<div class=\"bing\">";
  my $count = 0;

  foreach my $result (@{$data->{d}{results}}){
    $count++;
    last if($count > $results);

    my $Url = decode('JavaScript-UCS',$result->{Url});
    my $Description = decode('JavaScript-UCS',$result->{Description});
    my $Title = decode('JavaScript-UCS',$result->{Title});

    $out .= "$count.<a href=\"$Url\">$Title</a><br>";
    $out .= "<b>Url:</b> $Url<br>";
    $out .= "<b>Description:</b> $Description<br><br>";
  }

  $out .= "</div>";

  $out = Unicode::Japanese->new($out,"utf8")->euc;

#$out = Dumper $data;

  return $out;
}

1;

